/*
 * CountDown class.
 *
 * Copyright (C) 2007 SATOH Takayuki All Rights Reserved.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */
package ts.util;

import java.math.BigDecimal;

/**
 * カウントダウンクラス。
 * <br>
 * カウンタの値を保持し、それを一つずつ減算していくためのメソッドを
 * 用意している。
 * カウンタの下限値は、デフォルトではゼロに設定されるが、コンストラクタで指定
 * することもできる。
 * カウンタの初期値は必ずコンストラクタで指定しなければならない。
 * <br>
 * このクラスの直接のインスタンスはマルチスレッドに対応していないが、
 * {@link ts.util.CountDown#synchronizedCountDown}メソッドを利用して、
 * スレッドセーフなインスタンスを生成することができる。
 *
 * @author  佐藤隆之. 
 * @version $Revision: 1.1.1.1 $, $Date: 2010-10-16 00:03:43 $
 */
public class CountDown
{
  /** カウンタ。 */
  private long value_;

  /** 下限値。 */
  private long limit_;

  /**
   * カウンタの初期値を引数にとるコンストラクタ。
   * <br>
   * カウンタの下限値はゼロとする。カウンタの初期値が下限値よりも小さい場合も、
   * そのまま設定する。
   */
  public CountDown(long init)
  {
    this(init, 0L);
  }

  /**
   * カウンタの初期値と下限値を引数にとるコンストラクタ。
   * <br>
   * 初期値が下限値よりも小さい場合も、そのまま設定する。
   *
   * @param  init  カウンタの初期値。
   * @param  limit カウンタの下限値。
   */
  public CountDown(long init, long limit)
  {
    value_ = init;
    limit_ = limit;
  }

  /**
   * 現在のカウンタ値を取得する。
   *
   * @return 現在のカウンタ値。
   */
  public long currentValue()
  {
    return value_;
  }

  /**
   * 下限値を取得する。
   *
   * @return 下限値。
   */
  public long limitValue()
  {
    return limit_;
  }

  /**
   * カウンタの値が下限値に達したかどうかを判定する。
   *
   * @return カウンタの値が下限値よりも大きいか等しい場合は<tt>true</tt>
   *           を返し、そうでなければ<tt>false</tt>を返す。
   */
  public boolean isReached()
  {
    return (value_ <= limit_) ? true : false;
  }

  /**
   * カウンタを一つ減算する。
   * <br>
   * カウンタの値が下限値を越える場合には例外をスローする。
   * 
   * @return 減算後のカウンタ値。
   * @throws OutOfRangeException カウンタが下限値を越える場合。
   */
  public long decrement() throws OutOfRangeException
  {
    if (value_ <= limit_) {
      BigDecimal v = new BigDecimal(String.valueOf(value_));
      v.subtract(BigDecimal.valueOf(1L));
      BigDecimal s = BigDecimal.valueOf(limit_);
      throw new OutOfRangeException(v, s, null);
    }

    value_ --;
    return value_;
  }

  /**
   * カウンタの初期値を指定して、スレッドセーフなカウントダウンオブジェクト
   * を生成する。
   * <br>
   * カウンタの下限値はゼロとする。
   *
   * @param  init カウンタの初期値。
   * @return スレッドセーフなカウントダウンオブジェクト。
   */
  public static CountDown synchronizedCountDown(long init)
  {
    return synchronizedCountDown(init, 0L);
  }

  /**
   * カウンタの初期値及び下限値を指定して、スレッドセーフなカウントアップ
   * オブジェクトを生成する。
   * <br>
   * 初期値が下限値よりも小さい場合も、そのまま設定する。
   *
   * @param  init  カウンタの初期値。
   * @param  limit カウンタの下限値。
   */
  public static CountDown synchronizedCountDown(long init, long limit)
  {
    return new CountDown(init, limit) {
      @Override
      public synchronized long currentValue() {
        return super.currentValue();
      }
      @Override
      public synchronized boolean isReached() {
        return super.isReached();
      }
      @Override
      public synchronized long decrement() throws OutOfRangeException {
        return super.decrement();
      }
    };
  }

  /**
   * 指定されたカウントダウンオブジェクトの現在の値を使用して、
   * スレッドセーフなカウントダウンオブジェクトを新たに生成する。
   *
   * @param  c 元になるカウントダウンオブジェクト。
   * @return スレッドセーフなカウントダウンオブジェクト。
   * @throws AssertionError 引数がヌルの場合（デバッグモードのみ）。
   */
  public static CountDown synchronizedCountDown(CountDown c) 
  {
    assert (c != null) : "@param:c is null.";

    return synchronizedCountDown(c.currentValue(), c.limitValue());
  }
}
